/* Staal provisie tarieven voor binnenlandse transacties */
/* (C)Copyright 1995 by the Frobozz Magic Software Company */
/* fouten voorbehouden, de auteur aanvaardt geen aansprakelijkheid */
/* voor eventuele incorrecte waarden */
/* parms:
	1 - STOCK/OPTION/BOND
	2 - OPEN/CLOSE
	3 - count
	4 - price
*/

type = ARG(1)
oc = ARG(2)
count = ARG(3)
price = ARG(4)

val = count * price

select
	when type = 'STOCK' then do
		call setstocktable
		prov = tblprov(val)
		if prov < 100 then
			prov = 100
	end
	when type = 'BOND' then
		call setbondtable
		prov = tblprov(val)
	when type = 'OPTION' then
		prov = optionprov(oc, count, price)
	otherwise
		prov = 0
end

return prov

tblprov: procedure expose prv.

parse arg val

prov = 0
v = val
prev = 0

do i=1 to prv.0
	if v < prv.i.val then
		return prov + v * prv.i.perc / 100
	prov = prov + (prv.i.val - prev) * prv.i.perc / 100
	v = v - prv.i.val + prev
	prev = prv.i.val
end

i = prv.0 + 1

return val * prv.i.perc


optionprov:

parse arg open, count, price

op = 18
cp = 10

if price > 1.5 then do
	op = 22.50
	cp = 15
end

if open = 'OPEN' then do
	prov = op * count
	if prov < 60 then
		prov = 60
end
else do
	prov = cp * count
	if prov < 40 then
		prov = 40
end

return prov

setbondtable: procedure expose prv.

prv.0 = 5
prv.1.val = 7500;    prv.1.perc = 1.5
prv.2.val = 20000;   prv.2.perc = 1
prv.3.val = 100000;  prv.3.perc = 0.7
prv.4.val = 500000;  prv.4.perc = 0.4
prv.5.val = 1000000; prv.5.perc = 0.25
prv.6.perc = 0.36

return

setstocktable: procedure expose prv.

prv.0 = 3
prv.1.val = 7500;    prv.1.perc = 1.5
prv.2.val = 20000;   prv.2.perc = 1
prv.3.val = 1000000; prv.3.perc = 0.7
prv.4.perc = 0.7

return
