/* ING bank provisie tarieven voor binnenlandse transacties */
/* (C)Copyright 1995 by the Frobozz Magic Software Company */
/* fouten voorbehouden, de auteur aanvaardt geen aansprakelijkheid */
/* voor eventuele incorrecte waarden */
/* parms:
	1 - FUND/OPTION
	2 - SHARE/OPTION/BOND/CURRENCY/USER
	3 - OPEN/CLOSE
	4 - count
	5 - price
*/

trans = ARG(1)
fund = ARG(2)
oc = ARG(3)
count = ARG(4)
price = ARG(5)

val = count * price

if trans = 'FUND' then do
	select 	
		when type = 'SHARE' then do
			call setstocktable
			prov = tblprov(val)
			if prov < 100 then
				prov = 100
		end
		when type = 'BOND' then do
			call setbondtable
			prov = tblprov(val)
		end
		otherwise
			prov = 0
	end
	min.OPEN = 50
	min.CLOSE = 30
	if prov < min.oc then
		prov = min.oc
end
else
	prov = optionprov(fund, oc, count, price)

return prov

tblprov: procedure expose prv.

parse arg value

prov = 0
v = value
prev = 0

do i=1 to prv.0
	if v < prv.i.val then do
		if prv.i.type = 'I' then
			return prov + v * prv.i.perc / 100
		else
			return value * prv.i.perc / 100
	end
	prov = prov + (prv.i.val - prev) * prv.i.perc / 100
	v = v - prv.i.val + prev
	prev = prv.i.val
end

i = prv.0 + 1

return value * prv.i.perc

optionprov:

parse arg fund, oc, count, price

op.SHARE.LIMIT = 10
op.SHARE.OPEN.LOW.1 = 15
op.SHARE.OPEN.LOW.2 = 10
op.SHARE.OPEN.HIGH.1 = 22.5
op.SHARE.OPEN.HIGH.2 = 15
op.SHARE.OPEN.MIN = 40
op.SHARE.CLOSE.LOW.1 = 7.5
op.SHARE.CLOSE.LOW.2 = 5
op.SHARE.CLOSE.HIGH.1 = 15
op.SHARE.CLOSE.HIGH.2 = 10
op.SHARE.CLOSE.MIN = 30

op.BOND.LIMIT = 10
op.BOND.OPEN.LOW.1 = 7.5
op.BOND.OPEN.LOW.2 = 5
op.BOND.OPEN.HIGH.1 = 10
op.BOND.OPEN.HIGH.2 = 6.5
op.BOND.OPEN.MIN = 40
op.BOND.CLOSE.LOW.1 = 3.75
op.BOND.CLOSE.LOW.2 = 3
op.BOND.CLOSE.HIGH.1 = 5
op.BOND.CLOSE.HIGH.2 = 4
op.BOND.CLOSE.MIN = 30

op.CURRENCY.LIMIT = 8
op.CURRENCY.OPEN.LOW.1 = 18
op.CURRENCY.OPEN.LOW.2 = 12
op.CURRENCY.OPEN.HIGH.1 = 18
op.CURRENCY.OPEN.HIGH.2 = 12
op.CURRENCY.OPEN.MIN = 60
op.CURRENCY.CLOSE.LOW.1 = 7.5
op.CURRENCY.CLOSE.LOW.2 = 5
op.CURRENCY.CLOSE.HIGH.1 = 7.5
op.CURRENCY.CLOSE.HIGH.2 = 5
op.CURRENCY.CLOSE.MIN = 25

prov = 0

if price > 1.5 then 
	segment = 'HIGH' 
else 
	segment = 'LOW'

i = 1

if count > op.fund.LIMIT then do
	prov = op.fund.LIMIT * op.fund.oc.segment.i
	count = count - op.fund.LIMIT
	i = 2
end

prov = prov + count * op.fund.oc.segment.i

if prov < op.fund.oc.MIN then
	prov = op.fund.oc.MIN

return prov

setbondtable: procedure expose prv.

prv.0 = 5
prv.1.val = 5000;    prv.1.perc = 1.75;	prv.1.type = 'I'
prv.2.val = 20000;   prv.2.perc = 1;	prv.2.type = 'I'
prv.3.val = 500000;  prv.3.perc = 0.4;	prv.3.type = 'I'
prv.4.val = 1000000; prv.4.perc = 0.25;	prv.4.type = 'I'
prv.5.val = 2500000; prv.5.perc = 0.25;	prv.5.type = 'T'
prv.6.perc = 0.25

return

setstocktable: procedure expose prv.

prv.0 = 8
prv.1.val = 5000;    prv.1.perc = 1.75; prv.1.type = 'I'
prv.2.val = 20000;   prv.2.perc = 1;	prv.2.type = 'I'
prv.3.val = 1000000; prv.3.perc = 0.6;	prv.3.type = 'I'
prv.4.val = 2500000; prv.4.perc = 0.595;prv.4.type = 'T'
prv.5.val = 5000000; prv.5.perc = 0.49;	prv.5.type = 'T'
prv.6.val = 10000000;prv.6.perc = 0.385;prv.6.type = 'T'
prv.7.val = 15000000;prv.7.perc = 0.350;prv.7.type = 'T'
prv.8.perc = 0.245

return
