/* list all stocks */

Call RxFuncAdd 'StockLoadFuncs', 'RXSTOCK', 'StockLoadFuncs'

Call StockLoadFuncs

call StockSetPortfolio 'Van Keep Software bv'

/* eerst bekijken we de portefeuille op aandelen posities */

res = StockWalkTransStem(FIRST, 'TRANS')

grandtotal = 0
grandcost = 0

call GetOptions

say 'Fund                 Shares        Result         Costs'

do while res \= 0
	curfund = trans.fund
	total = 0
	cost = 0
	shares = 0
       	call StockSetStock curfund
	disp = 0
	do while res \= 0 & curfund = trans.fund
/*		if left(trans.date,2) = '95' then do*/
		amt = trans.amount
		if trans.option then do
			total = total - 100 * amt * CalcOptPrice(trans.fund, trans.price, trans.date, trans.call, trans.exprice, trans.exdate)
			cost = cost + trans.costs
			disp = 1
			call StockSetStock curfund
		end
/*		else do
			total = total - amt * CalcPrice(trans.price, trans.date)
			shares = shares + amt
		end */
		/* end */
		res = StockWalkTransStem(NEXT, 'TRANS')
	end
	if disp then
		say substr(curfund, 1, 16) format(shares,10,0) format(total,10,2) format(cost,10,2)
	grandtotal = grandtotal + total
	grandcost = grandcost + cost
end

say 'Grandtotal  = ' grandtotal
say 'Total costs = ' grandcost
say 'Net total   = ' grandtotal - grandcost

return

CalcPrice:

parse arg val, trdat

res = StockWalkDividend(FIRST)

do while res \= ''
	parse var res divdate divamt
	if divdate > trdat then
		val = val - divamt
	res = StockWalkDividend(NEXT)
end

int = StockQueryStockData(INTEREST)
today = date('B')

start = julian(trdat)

val = val - int * (today - start) / 365.2425

res = StockQueryStockData(CURRENCY)

if res \= '' then do
	call StockSetStock res
	val = val * StockGetQuote(trdat) / 100
end	

return val


CalcOptPrice:

parse arg stock, val, trdat, cl, expr, exdat

if cl = 0 then
	cl = 'P'
else
	cl = 'C'

v = globals.!Stock.stock.cl.expr.exdat

if DATATYPE(v, 'Number') then
	val = val - v

res = StockQueryStockData(CURRENCY)

if res \= '' then do
	call StockSetStock res
	val = val * StockGetQuote(trdat) / 100
end	

return val

julian: procedure

if ARG() = 1 then do
	parse arg y 3 m 5 d
	y = y + 1900
end
else
	parse arg d, m, y

if m < 3 then do
	m = m + 12
	y = y - 1
end
y = y - 1
m = m - 1

return 365 * y + y % 4 -  y % 100 + y % 400 + m * 31 - (4 * m + 23) % 10 + d - 1

GetOptions: procedure expose globals.

res = StockWalkStocks(FIRST)

say 'Verzamelen optienoteringen...'

do while res\= ''
	opt = StockWalkOptions(FIRST)
	do while opt \= ''
		parse var opt cal ser month year last high low age
		xd = 100 * year + month
		globals.!Stock.res.cal.ser.xd = last
		opt = StockWalkOptions(NEXT)
	end
	res = StockWalkStocks(NEXT)
end

say 'Klaar!'

return
