/* Staal provisie tarieven voor binnenlandse transacties */
/* (C)Copyright 1995 by the Frobozz Magic Software Company */
/* fouten voorbehouden, de auteur aanvaardt geen aansprakelijkheid */
/* voor eventuele incorrecte waarden */
/* parms:
	1 - FUND/OPTION
	2 - SHARE/OPTION/BOND/CURRENCY/USER
	3 - OPEN/CLOSE
	4 - count
	5 - price
*/

trans = ARG(1)
type = ARG(2)
oc = ARG(3)
count = ARG(4)
price = ARG(5)

val = count * price

if trans = 'FUND' then do
	select 	
		when type = 'SHARE' then do
			call setstocktable
			prov = tblprov(val)
			if prov < 100 then
				prov = 100
		end
		when type = 'BOND' then do
			call setbondtable
			prov = tblprov(val)
		end
		otherwise
			prov = 0
	end
	prov = prov * 0.7
end
else
	prov = optionprov(oc, count, price)

return prov

tblprov: procedure expose prv.

parse arg value

prov = 0
v = value
prev = 0

do i=1 to prv.0
	if v < prv.i.val then
		return prov + v * prv.i.perc / 100
	prov = prov + (prv.i.val - prev) * prv.i.perc / 100
	v = v - prv.i.val + prev
	prev = prv.i.val
end

i = prv.0 + 1

return value * prv.i.perc


optionprov:

parse arg action, count, price

op.1.OPEN = 18
op.1.CLOSE = 10
op.2.OPEN = 22.5
op.2.CLOSE = 15
min.OPEN = 60
min.CLOSE = 40

if price > 1.5 then 
	i = 2 
else 
	i = 1

prov = op.i.action * count

if prov < min.action then
	prov = min.action

if count > 10 then do
	prov = prov * (3 * count + 10) / (4 * count)
end

return prov

setbondtable: procedure expose prv.

prv.0 = 5
prv.1.val = 7500;    prv.1.perc = 1.5
prv.2.val = 20000;   prv.2.perc = 1
prv.3.val = 100000;  prv.3.perc = 0.7
prv.4.val = 500000;  prv.4.perc = 0.4
prv.5.val = 1000000; prv.5.perc = 0.25
prv.6.perc = 0.36

return

setstocktable: procedure expose prv.

prv.0 = 3
prv.1.val = 7500;    prv.1.perc = 1.5
prv.2.val = 20000;   prv.2.perc = 1
prv.3.val = 1000000; prv.3.perc = 0.7
prv.4.perc = 0.7

return
