/*	
**	Frobozz Stock
**	(C)Copyright by the Frobozz Magic Software Company 1993-1994
**	Rexx chart procedure
**
**	TRIX indicator
**	percent change of triply smoothed ema
**
**	version 1.0
**	author	PvK
**	date	feb 24, 1994
*/

/*
**	first handle any system information requests
**	this is compulsory and may not be omitted
*/
if (ARG(1) = "SYSTEM") then do
    select
	/* return full description of function */
	when ARG(2) = "NAME" then
		return "TRIX indicator"
	/* return internal id of function
	** can be used when calling quote function
	** this id is only a default, if the user assigns another one
	** to an implementation, that id is used
	*/
	when ARG(2) = "ID" then
		return "TRIX"
	/* determine number & parameter types 
	** S=string, I=integer parameter
	** although REXX doesn't care, this is to prevent the user from
	** entering silly parameters
	*/
	when ARG(2) = "PARMS" then
		return "I"
	/* description of user parameters */
	when ARG(2) = "PARMDESC" then
		return "(period)"
	/* number of lines to plot */
	when ARG(2) = "PLOTS" then
		return 1
	otherwise
		return 0
    end
end

days = ARG(1)

v = ARG(2)

parse var v p ma1 ma2 ma3 d


if (v = "0") then
	return 0 0 0 0 1

d = d + 1

if (d = 2) then do
	ma1 = (Quote("C", 0) + Quote("C", 1)) / 2
	ma2 = ma1
	ma3 = ma1
	ma4 = ma3
end
else do
	if (d < days) then 
		x = 2 / (d + 1)
	else 
		x = 2 / (days + 1)
	ma1 = ma1 + x * (Quote("C", 0) - ma1)
	ma2 = ma2 + x * (ma1 - ma2)
	ma4 = ma3 + x * (ma2 - ma3)
end


return 10000 * (ma4 - ma3) / ma3 ma1 ma2 ma4 d
